
Partial Class _Insert
  Inherits System.Web.UI.Page

  Protected Sub butDiplayResults_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles butDiplayResults.Click
    Try
      Dim wbsMethodAPI As New MethodAPI.Service
      Dim sResult As String 'tells us Success or error
      Dim datResponse As Data.DataSet = Nothing

      'Get the Method Account values from web page
      Dim sCompanyAccount As String
      Dim sUserName As String
      Dim sPassword As String
      sCompanyAccount = Me.txtCompanyAccount.Text
      sUserName = Me.txtUserName.Text
      sPassword = Me.txtPassword.Text

      'Get the insert table from the screen
      Dim sInsertTable As String
      Dim intRecordID As Integer
      sInsertTable = Me.txtInsertTable.Text

      'build the array of fields to insert - in reality, there is no limit to the size of the array and 
      '  number of fields you can insert at once, but here we just use 2 fields
      Dim arrInsertFieldsArray(1) As String
      Dim arrInsertValueArray(1) As String
      arrInsertFieldsArray(0) = Me.txtInsertField1.Text
      arrInsertValueArray(0) = Me.txtInsertValue1.Text
      arrInsertFieldsArray(1) = Me.txtInsertField2.Text
      arrInsertValueArray(1) = Me.txtInsertValue2.Text

      'Call the MethodAPI to insert the records
      sResult = wbsMethodAPI.MethodAPIInsertV2(sCompanyAccount, sUserName, sPassword, _
      "", sInsertTable, arrInsertFieldsArray, arrInsertValueArray)
      wbsMethodAPI = Nothing

      Dim xmlDoc As New System.Xml.XmlDocument
      Dim objNodeList As System.Xml.XmlNodeList
      Dim objAttribute As System.Xml.XmlAttribute

      'START: Make sure the request was successful
      If InStr(1, sResult.ToUpper, "MethodAPI response = ""Success".ToUpper) = 0 Then
        'failed, give a message
        If Strings.Left(sResult, Len("<?xml")) = "<?xml" Then
          xmlDoc.LoadXml(sResult)
          objNodeList = xmlDoc.GetElementsByTagName("MethodAPI")
          For Each objAttribute In objNodeList.Item(0).Attributes
            If objAttribute.Name = "response" Then
              sResult = objAttribute.Value
            End If
          Next
        Else
          sResult = "Error"
        End If
      Else
        'all good
        xmlDoc.LoadXml(sResult)
        objNodeList = xmlDoc.GetElementsByTagName("MethodAPI")
        For Each objAttribute In objNodeList.Item(0).Attributes
          If objAttribute.Name.ToUpper = "RecordID".ToUpper Then
            intRecordID = objAttribute.Value
          End If
        Next
        sResult = "Success"
      End If
      'END: Make sure the request was successful

      'display result
      If sResult.Trim.ToUpper.StartsWith("Success".ToUpper) = True Then
        Me.divResponse.InnerHtml = "Successfully inserted, returned RecordID of " & intRecordID
      Else
        Me.divResponse.InnerHtml = sResult
      End If

      datResponse = Nothing

    Catch ex As Exception
      Me.divResponse.InnerHtml = ex.Message
    End Try
  End Sub

  Protected Sub butClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles butClear.Click
    Try
      Me.divResponse.InnerHtml = ""
    Catch ex As Exception
      Me.divResponse.InnerHtml = ex.Message
    End Try
  End Sub
End Class
