
Partial Class _SendToDesktop
  Inherits System.Web.UI.Page

  Protected Sub butDiplayResults_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles butDiplayResults.Click
    Try
      Dim wbsMethodAPI As New MethodAPI.Service
      Dim sResult As String 'tells us Success or error
      Dim datResponse As Data.DataSet = Nothing

      'Get the Method Account values from web page
      Dim sCompanyAccount As String
      Dim sUserName As String
      Dim sPassword As String
      sCompanyAccount = Me.txtCompanyAccount.Text
      sUserName = Me.txtUserName.Text
      sPassword = Me.txtPassword.Text

      'Build array fields to insert into invoices
      Dim arrInsertFieldsArray_Invoice(2) As String
      Dim arrInsertValueArray_Invoice(2) As String
      Dim intInvoiceRecordID As Integer
      arrInsertFieldsArray_Invoice(0) = "Customer"
      arrInsertValueArray_Invoice(0) = Me.txtCustomer.Text
      arrInsertFieldsArray_Invoice(1) = "TxnDate"
      arrInsertValueArray_Invoice(1) = CStr(Me.calTxnDate.SelectedDate.Year) & "-" _
      & Format(Me.calTxnDate.SelectedDate.Month, "0#") & "-" & Format(Me.calTxnDate.SelectedDate.Day, "0#")
      'add universal time of noon.  If you wanted to put in 5:25:33 PM Central you would put " 23:25:33",
      ' since 5:25 PM Central is 11:25 PM at night in universal time
      arrInsertValueArray_Invoice(1) &= " 12:00:00"
      arrInsertFieldsArray_Invoice(2) = "ARAccount"
      arrInsertValueArray_Invoice(2) = Me.txtARAccount.Text

      'MethodAPI to insert the invoice
      sResult = wbsMethodAPI.MethodAPIInsertV2(sCompanyAccount, sUserName, sPassword, _
       "", "Invoice", arrInsertFieldsArray_Invoice, arrInsertValueArray_Invoice)

      Dim xmlDoc As New System.Xml.XmlDocument
      Dim objNodeList As System.Xml.XmlNodeList
      Dim objAttribute As System.Xml.XmlAttribute

      'START: Make sure the request was successful
      If InStr(1, sResult.ToUpper, "MethodAPI response = ""Success".ToUpper) = 0 Then
        'failed, give a message
        If Strings.Left(sResult, Len("<?xml")) = "<?xml" Then
          xmlDoc.LoadXml(sResult)
          objNodeList = xmlDoc.GetElementsByTagName("MethodAPI")
          For Each objAttribute In objNodeList.Item(0).Attributes
            If objAttribute.Name = "response" Then
              sResult = objAttribute.Value
            End If
          Next
        Else
          sResult = "Error"
        End If
        'failed, give a message
        wbsMethodAPI = Nothing
        Me.divResponse.InnerHtml = sResult
        Exit Sub
      Else
        'all good
        xmlDoc.LoadXml(sResult)
        objNodeList = xmlDoc.GetElementsByTagName("MethodAPI")
        For Each objAttribute In objNodeList.Item(0).Attributes
          If objAttribute.Name.ToUpper = "RecordID".ToUpper Then
            intInvoiceRecordID = objAttribute.Value
          End If
        Next
        sResult = "Success"
      End If
      'END: Make sure the request was successful


      'Build array fields to insert invoice lines into invoices
      Dim arrInsertFieldsArray_InvoiceLine(2) As String
      Dim arrInsertValueArray_InvoiceLine(2) As String
      Dim intInvoiceLineRecordID As Integer
      arrInsertFieldsArray_InvoiceLine(0) = "Item"
      arrInsertValueArray_InvoiceLine(0) = Me.txtItem.Text
      arrInsertFieldsArray_InvoiceLine(1) = "Rate"
      arrInsertValueArray_InvoiceLine(1) = Me.txtRate.Text
      arrInsertFieldsArray_InvoiceLine(2) = "InvoiceRecordID"
      arrInsertValueArray_InvoiceLine(2) = intInvoiceRecordID

      'MethodAPI to insert the invoiceline, now that we know the invoice's recordid
      sResult = wbsMethodAPI.MethodAPIInsert(sCompanyAccount, sUserName, sPassword, _
       "InvoiceLine", arrInsertFieldsArray_InvoiceLine, arrInsertValueArray_InvoiceLine, intInvoiceLineRecordID)
      If sResult.Trim.ToUpper.StartsWith("Success".ToUpper) = False Then
        'failed, give a message
        wbsMethodAPI = Nothing
        Me.divResponse.InnerHtml = sResult
        Exit Sub
      End If

      'MethodAPI to call the invoice to send to QuickBooks.  It wouldn't have gone through to QuickBooks
      'when the invoice was first inserted since there weren't any line items.  
      'this SendToDesktop lets the invoice know that it is finished adding line items and can finally go to QuickBooks
      sResult = wbsMethodAPI.MethodAPIActionSendToDesktop(sCompanyAccount, sUserName, sPassword, _
       "Invoice", intInvoiceRecordID)

      'give the final response
      Me.divResponse.InnerHtml = sResult

      datResponse = Nothing
      wbsMethodAPI = Nothing

    Catch ex As Exception
      Me.divResponse.InnerHtml = ex.Message
    End Try
  End Sub

  Protected Sub butClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles butClear.Click
    Try
      Me.divResponse.InnerHtml = ""
    Catch ex As Exception
      Me.divResponse.InnerHtml = ex.Message
    End Try
  End Sub
End Class
